//+------------------------------------------------------------------+
//|ONLY PIVOT_B Rev1                            @@@@@@@@@   |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+



#property copyright "Masa9390"


extern double  Lots   = 0.1;
extern double  TrailingStop   =  50;

extern int     Nbars  = 2;


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
   {
  

   bool  PivBuy      =  false; //Entry Signal
   bool  PivSel      =  false;
   bool  PivSelCx    =  false; //Close Signal
   bool  PivBuyCx    =  false;
   bool  JustOpenH1  =  false;
   bool  NewDay      =  false;

   int   cnt,ticket,total,N=2;

   string cmt="OnlyPivot_B Rev0";
  

// at time=01:00, the datas at 00:00 are not used. They make noise signals. Use datas 23:00 of past day.


   if (TimeDay(iTime(NULL,PERIOD_H1,1))!=TimeDay(iTime(NULL,PERIOD_H1,2))) 
      {
      NewDay=true;     
      }

   
// at time=02:00 use the datas at 23:00 and 01:00 for signal.

   if (TimeDay(iTime(NULL,PERIOD_H1,1))!=TimeDay(iTime(NULL,PERIOD_H1,3)))
      {
      N=N+1;     
      }

//Chech just start new H1 Bar.

   if (!GlobalVariableCheck("intHour")) 
      {
      GlobalVariableSet("intHour",99);
      }
   
   if (GlobalVariableGet("intHour")!=TimeHour(iTime(NULL,0,0)))
      {
      JustOpenH1=true;
      GlobalVariableSet("intHour",TimeHour(iTime(NULL,0,0)));
      }
      


//Check entry signals

   if (JustOpenH1==true && !TimeHour(iTime(NULL,PERIOD_H1,0))==0)
   if (NewDay==false)
      {   
      if (iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,N) > iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,N))  //FDayPivot > 2 SMMA WEIGHTED Shift 2hour
      if (iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,1) < iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,1))  //:DayPivot<2 SMMA WEIGHTED Shift 1hour 
         {
         PivBuy  =  true;
         }

      if (iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,N) < iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,N))  //FDayPivot < FlowPivot Shift 2hour
      if (iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,1) > iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,1))  //FDayPivot > FlowPivot Shift 1hour
         {
         PivSel  =  true;
         }
 
      }


//Check close signals

   if (JustOpenH1==true)
      {   
      if (iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,N) > iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,N))  //FDayPivot > 2 SMMA WEIGHTED Shift 2hour
      if (iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,1) < iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,1))  //:DayPivot<2 SMMA WEIGHTED Shift 1hour
         {
         PivSelCx  =  true;  
         }
      if (iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,N) < iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,N))  //FDayPivot < FlowPivot Shift 2hour
      if (iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,1) > iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,1))  //FDayPivot > FlowPivot Shift 1hour
         {
         PivBuyCx  =  true;
         }     
      }
   

// Order Buy

   total=OrdersTotal();
   if(total<1 && PivBuy == true) 
   if (JustOpenH1==true)
   if (NewDay==false)
   
      {
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,0,Ask-TrailingStop*Point,0,"OnlyPiv_B",0,0,Green);
   
      if(ticket>0)
         {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0);    
         }
      }

//Order Sell
   
   total=OrdersTotal();
   if(total<1 && PivSel == true) 
   if (JustOpenH1==true)
   if (NewDay==false)
      {
//      cmt="S Piv=" + iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,N)+" MA="+iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,N)+" N="+N;
//      cmt=cmt+"Piv1="+iCustom(NULL,PERIOD_H1,"PrevDayAndFloatingPivot_O",0,1)+" MA1="+iMA(NULL,PERIOD_H1,Nbars,0,MODE_SMMA,PRICE_WEIGHTED,1);
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,0,Bid+TrailingStop*Point,0,cmt,0,0,Red);
    
      if(ticket>0)
         {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0);    
         }
      }

   

// Close and next order
 

   for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
         {
         if(OrderType()==OP_BUY)   // long position is opened
            {
//TrailingStop
            //Print("**Bid=",Bid," OpenPrice=",OrderOpenPrice()," TS=",Point*TrailingStop);
            if (TrailingStop > 0)
            if (Bid-OrderOpenPrice()   >   Point*TrailingStop)
            if((OrderStopLoss()<Bid-Point*TrailingStop)||(OrderStopLoss()==0))
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Yellow);
               }
// should it be closed?
            
            if (PivBuyCx==true)          
               {  
               OrderClose(OrderTicket(),OrderLots(),Bid,0,Black); // close position

//Reverse Order
               if (JustOpenH1==true)
               if (PivSel==true)          
                  {
                  ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,0,Bid+TrailingStop*Point,0,"OnlyPiv_S",0,0,Red);
                  if(ticket>0)
                     {
                      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
                      else Print("Error opening SELL order : ",GetLastError()); 
                      return(0);    

                     }
                  }  
               }  
            }  
         }  
      }     
   
   for(cnt=0;cnt<total;cnt++)
      {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
         {        
         if(OrderType()==OP_SELL)   // long position is opened
//TrailingStop

            {
            if (TrailingStop > 0)
            if (OrderOpenPrice()-Ask   >  Point*TrailingStop)
            if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Yellow);
               return(0);
               }
            }
         }
              
// should it be closed?
            
      if (PivSelCx == true)          
         {
         OrderClose(OrderTicket(),OrderLots(),Ask,0,Black); // close position
              
         if (JustOpenH1==true)
         if (PivBuy == true)          

            ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,0,Ask-TrailingStop*Point,0,"OnlyPiv_B",0,0,Green);
    
         if(ticket>0)
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0);    
             
         }               
      }
   }


     
//----
   return(0);
   
//+------------------------------------------------------------------+
 